import sun.java2d.Disposer;

import java.util.Objects;

/**
 * Tile for Scrabble This is an immutable class. Can't change attributes
 *
 * @author hajo
 */
// Inv: glyph != null && points > 0
public class Tile {

    private final String glyph; // Could be blank, black or arrow
    private final int points;
    private boolean frozen = false;   // Is this a temporarily (possible to remove from board)?

    public Tile(String glyph, int points) {
        if (glyph == null) {
            throw new IllegalStateException("Glyph null");
        }
        if (points <= 0) {
            throw new IllegalStateException("points <= 0");
        }
        this.glyph = glyph;
        this.points = points;
    }

    public String getGlyph() {
        return glyph;
    }

    public int getPoints() {
        return points;
    }

    public boolean isFrozen() {
        return frozen;
    }

    public void freeze() {
        this.frozen = true;
    }

    @Override
    public String toString() {
        return "[" + glyph + "," + points + "]";
    }

}
